LeetCode:34. 在排序数组中查找元素的第一个和最后一个位置

简介

题目链接:https://leetcode.cn/problems/find-first-and-last-position-of-element-in-sorted-array/description/

解决方式:数组 + 二分查找

这是作者学习众多大神的思路进行解题的步骤,很推荐大家解题的时候去看看题解里面大佬们的思路、想法!

二分查找

思路:这题是704二分查找题目的进一步,涉及到左右边界问题。在二分查找的基础上找到目标元素不返回,而是进一步收缩区间范围,找到左右边界。这题做了个转换,并不是找到左边界之后修改算法直接找右边界,而是将目标元素 + 1,复用查找左边界的二分算法,找比目标元素大一点元素的左边界,找到后该左边界 - 1 就是目标元素的右边界了。

具体可参考labuladong(704)、灵茶山艾府大佬关于二分查找一系列的详细题解!

java 复制代码
class Solution {
    public int[] searchRange(int[] nums, int target) {
        // 边界处理
        if(nums.length == 0){
            return new int[]{-1, -1};
        }
        // 二分查找
        int first = left(nums, target);
        // 有几种情况
        // 一种目标元素比所有元素都大,left == nums.length
        // 一种目标元素在数组范围中,但不存在目标元素,nums[first] != target
        if(first == nums.length || nums[first] != target){
            return new int[]{-1, -1};
        }
        // 复用二分查找,使 target + 1,寻找比目标元素大一点的元素的左边界,其 -1 即目标元素的右边界
        int second = left(nums, target + 1) - 1;
        // 进行到这一步必定找的到,所以直接返回结果
        return new int[]{first, second};
    }
    // 二分函数
    private int left(int[] nums, int target){
        int left = 0;
        int right = nums.length - 1;
        int mid = 0;
        // 左右闭合区间
        while(left <= right){
            mid = left + (right - left) / 2;
            if(nums[mid] < target){
                // 目标在右侧
                left = mid + 1;
            }else if(nums[mid] > target){
                // 目标在左侧
                right = mid - 1;
            }else{
                // 正中目标,找左边界
                right = mid - 1;
            }
        }
        // 返回左边界
        return left;
    }
}

优化

思路:上面复用二分查找的时候直接传递了整个数组,其实不用,因为比目标元素大一的元素一定在右侧,所以我们只需要查询右侧的数组元素就好。

java 复制代码
class Solution {
    public int[] searchRange(int[] nums, int target) {
        // 边界处理
        if(nums.length == 0){
            return new int[]{-1, -1};
        }
        // 二分查找
        int first = left(nums, target, 0, nums.length - 1);
        // 有几种情况
        // 一种目标元素比所有元素都大,left == nums.length
        // 一种目标元素在数组范围中,但不存在目标元素,nums[first] != target
        if(first == nums.length || nums[first] != target){
            return new int[]{-1, -1};
        }
        // 复用二分查找,使 target + 1,寻找比目标元素大一点的元素的左边界,其 -1 即目标元素的右边界
        // 优化,缩小数组范围
        int second = left(nums, target + 1, first + 1, nums.length - 1) - 1;
        // 进行到这一步必定找的到,所以直接返回结果
        return new int[]{first, second};
    }
    // 二分函数
    private int left(int[] nums, int target, int leftBound, int rightBound){
        int left = leftBound;
        int right = rightBound;
        int mid = 0;
        // 左右闭合区间
        while(left <= right){
            mid = left + (right - left) / 2;
            if(nums[mid] < target){
                // 目标在右侧
                left = mid + 1;
            }else if(nums[mid] > target){
                // 目标在左侧
                right = mid - 1;
            }else{
                // 正中目标,找左边界
                right = mid - 1;
            }
        }
        // 返回左边界
        return left;
    }
}
相关推荐
P.D.Wei18 分钟前
[Leetcode 1614] 括号的最大嵌套深度
算法·leetcode·职场和发展
红姐跨境书42 分钟前
AI 的底层逻辑:从数据、算法到智能的本质
人工智能·算法
繁华的地方不一定留下你的脚印42 分钟前
C++ 算法与 ranges:用 find_if、transform 写清数据处理意图
开发语言·c++·算法
张小姐的猫44 分钟前
【AI大模型接入SDK】 —— 前端页面 & 项目总结与拓展
前端·数据结构·数据库·c++·人工智能·chatgpt
青山是哪个青山44 分钟前
LeetCode 64:最小路径和
算法
blxr_1 小时前
力扣hot100寻找重复数https://leetcode.cn/problems/find-the-duplicate-number/
算法·leetcode·职场和发展
政企项目老覃1 小时前
金融医疗数据脱敏与隐私计算:从字段打码到联邦建模的落地复盘
程序人生·算法·金融·数据分析
❀͜͡傀儡师1 小时前
Spring Boot 实现图片盲水印:基于 DCT 频域算法的隐形数字水印
spring boot·算法
Zane19941 小时前
贪心算法大多靠不住,为什么Dijkstra的贪心选择偏偏能保证全局最优
算法
CQU_JIAKE1 小时前
9.26【A】
算法